# coding: utf-8

"""
    Order API

    The Order API provides interfaces that let shoppers pay for items (for both eBay guest and eBay member buyers). It also returns payment and shipping status of the order. It enables eBay partners to use accept payment without being <a href=\"https://www.pcisecuritystandards.org/\">PCI compliant</a> and use the <a href=\"/api-docs/buy/static/api-order.html#Post\">Post Order API</a> for returns and cancellations for eBay member buyers.   <p>The Order API has the following resources:  </p>  <ul>  <li><b>checkout_session:</b> Lets eBay members purchase items using PayPal or a credit card.</li>  <li><b>guest_checkout_session:</b> Lets eBay guests purchase items using a credit card or the <a href=\"/api-docs/buy/static/api-order.html#spb-checkout\">PayPal Smart Button</a>.</li>   <li><b>proxy_guest_checkout_session:</b> Lets eBay guests purchase items through a <a href=\"/api-docs/buy/static/api-order.html#vsp-checkout\">vault service provider</a> (VSP). &nbsp;&nbsp;<b>*Note:* </b>Due to the requirement of having a VSP, this resource is not available in the eBay <a href=\"https://developer.ebay.com/my/api_test_tool?index=0\">API Explorer</a>.</li>  <li><b>guest_purchase_order</b> and <b>purchase_order:</b> Lets eBay partners track the payment status and show the buyers their purchase order. </li> </ul>  # noqa: E501

    OpenAPI spec version: v1_beta.29.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class UpdateShippingOption(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'line_item_id': 'str',
        'shipping_option_id': 'str'
    }

    attribute_map = {
        'line_item_id': 'lineItemId',
        'shipping_option_id': 'shippingOptionId'
    }

    def __init__(self, line_item_id=None, shipping_option_id=None):  # noqa: E501
        """UpdateShippingOption - a model defined in Swagger"""  # noqa: E501
        self._line_item_id = None
        self._shipping_option_id = None
        self.discriminator = None
        if line_item_id is not None:
            self.line_item_id = line_item_id
        if shipping_option_id is not None:
            self.shipping_option_id = shipping_option_id

    @property
    def line_item_id(self):
        """Gets the line_item_id of this UpdateShippingOption.  # noqa: E501

        A unique eBay-assigned ID value that identifies the line item in a checkout session.  # noqa: E501

        :return: The line_item_id of this UpdateShippingOption.  # noqa: E501
        :rtype: str
        """
        return self._line_item_id

    @line_item_id.setter
    def line_item_id(self, line_item_id):
        """Sets the line_item_id of this UpdateShippingOption.

        A unique eBay-assigned ID value that identifies the line item in a checkout session.  # noqa: E501

        :param line_item_id: The line_item_id of this UpdateShippingOption.  # noqa: E501
        :type: str
        """

        self._line_item_id = line_item_id

    @property
    def shipping_option_id(self):
        """Gets the shipping_option_id of this UpdateShippingOption.  # noqa: E501

        A unique ID for the selected shipping option/method. Note: A list of valid shipping option IDs for a given line item can be retrieved using the getCheckoutSession or initiateCheckoutSession method.  # noqa: E501

        :return: The shipping_option_id of this UpdateShippingOption.  # noqa: E501
        :rtype: str
        """
        return self._shipping_option_id

    @shipping_option_id.setter
    def shipping_option_id(self, shipping_option_id):
        """Sets the shipping_option_id of this UpdateShippingOption.

        A unique ID for the selected shipping option/method. Note: A list of valid shipping option IDs for a given line item can be retrieved using the getCheckoutSession or initiateCheckoutSession method.  # noqa: E501

        :param shipping_option_id: The shipping_option_id of this UpdateShippingOption.  # noqa: E501
        :type: str
        """

        self._shipping_option_id = shipping_option_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(UpdateShippingOption, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, UpdateShippingOption):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
